Imports System
Module Module1

Interface IGameWeapon
	ReadOnly Property NumOfRounds() As Double
	Function Fire(ByVal TargetLocationX As Double, _
					ByVal TargetLocationY As Double, _
					ByVal TargetLocationZ As Double) _
					As Boolean
	Sub Reload(ByVal Rounds As Integer)
End Interface

Public Class CMachineGun
	Implements IGameWeapon
        
	Private m_intMagazine As Integer
       
	ReadOnly Property NumOfRounds() As Double _
			Implements IGameWeapon.NumOfRounds
		Get
			NumOfRounds = m_intMagazine
		End Get
	End Property
        
	Public Function Fire(ByVal TargetLocationX As Double, _
					ByVal TargetLocationY As Double, _
					ByVal TargetLocationZ As Double) _
					As Boolean Implements IGameWeapon.Fire
		
		Dim rndRandomGen As New Random()
		Dim intRndNumber As Integer
            
		If m_intMagazine > 1 Then
			m_intMagazine -= 1
			Fire = True
		Else
			Console.WriteLine("Out of ammo!")
			Fire = False
		End If
            
		intRndNumber = rndRandomGen.Next(1, 10)
		Console.Write("{0} ", intRndNumber)
		If intRndNumber <= 5 Then
			Console.WriteLine("Machine gun: Target missed!")
		End If
            
		If intRndNumber >= 6 Then
			Console.WriteLine("Machine gun: Target hit!")
		End If
	End Function
        
	Public Sub Reload(ByVal Rounds As Integer) _
					Implements IGameWeapon.Reload
		If Rounds + m_intMagazine > 50 Then
			Console.WriteLine("Machine gun magazine at capacity")
		Else
			m_intMagazine += Rounds
		End If

	End Sub

End Class
    
    
Public Class CRocketLauncher
	Implements IGameWeapon
       
	Private m_intTubeCount As Integer
        
	ReadOnly Property NumOfRounds() As Double _
		Implements IGameWeapon.NumOfRounds
		Get
			NumOfRounds = m_intTubeCount
		End Get
	End Property
        
	Public Function Fire(ByVal TargetLocationX As Double, _
					ByVal TargetLocationY As Double, _
					ByVal TargetLocationZ As Double) _
					As Boolean Implements IGameWeapon.Fire
		Dim rndRandomGen As New Random()
		Dim intRndNumber As Integer
            
		If m_intTubeCount > 1 Then
			m_intTubeCount -= 1
			Fire = True
		Else
			Console.WriteLine("Out of rockets!")
			Fire = False
		End If
            
		intRndNumber = rndRandomGen.Next(0, 10)
            
		Console.Write("{0} ", intRndNumber)
            
		If intRndNumber <= 3 Then
			Console.WriteLine("Rocket: Target missed!")
		End If
            
		If intRndNumber >= 4 Then
			Console.WriteLine("Rocket: Target hit!")
		End If

	End Function
        
	Public Sub Reload(ByVal Rounds As Integer) _
		Implements IGameWeapon.Reload
		
		If Rounds + m_intTubeCount > 5 Then
			Console.WriteLine("No more rockets can be loaded")
		Else
			m_intTubeCount += Rounds
		End If
	
	End Sub
        
End Class

Sub ReloadAndAttack(ByVal Weapon As IGameWeapon)
        
	Weapon.Reload(5)
	If Not Weapon.Fire(1, 2, 3) Then
		Console.WriteLine("Run for cover!")
	End If
        
End Sub
    
Sub Main()
	Dim objMachineGun As New CMachineGun()
	Dim objRocketLauncher As New CRocketLauncher()
        
	ReloadAndAttack(objMachineGun)
	ReloadAndAttack(objRocketLauncher)
	Console.ReadLine()
End Sub
End Module