Imports System
Imports System.Data
Imports System.Xml
Imports Microsoft.VisualBasic

Module Module1

    Sub Main()

        Dim objDS As DataSet
        Dim objDT As DataTable
        Dim objIT As DataTable
        Dim objDC As DataColumn
        Dim aDC(1) As DataColumn
        Dim objProduct_SKU As DataColumn
        Dim objInventory_SKU As DataColumn

        objDS = New DataSet("Supermarket")

        objDT = New DataTable("Product")
        With objDT.Columns
            .Add("ProductSKU", _
                    Type.GetType("System.String"))
            .Add("ProductDescription", _
                    Type.GetType("System.String"))
        End With
        objDS.Tables.Add(objDT)

        aDC(0) = objDT.Columns("ProductSKU")
        objDT.PrimaryKey = aDC

        objDT = New DataTable("Inventory")
        With objDT.Columns
            .Add("InventoryRecordNum", _
                    Type.GetType("System.Int32"))
            .Add("InventorySKU", _
                    Type.GetType("System.String"))
            .Add("InventoryQuantity", _
                    Type.GetType("System.Int32"))
            .Add("InventoryBinNumber", _
                    Type.GetType("System.String"))
            .Add("InventoryExpirationDate", _
                    Type.GetType("System.DateTime"))
        End With
        objDS.Tables.Add(objDT)

        aDC(0) = objDT.Columns("InventoryRecordNum")
        objDT.PrimaryKey = aDC



        With objDT.Columns("InventoryRecordNum")
            .AutoIncrement = True
            .AutoIncrementSeed = 1
            .AutoIncrementStep = 1
        End With

        objProduct_SKU = objDS.Tables("Product").Columns("ProductSKU")
        objInventory_SKU = objDS.Tables("Inventory").Columns("InventorySKU")
        objDS.Relations.Add(New DataRelation( _
                            "fk_ProductSKU", _
                            objProduct_SKU, _
                            objInventory_SKU))


        Console.WriteLine("DataSet contains these tables:")
        For Each objDT In objDS.Tables
            Console.WriteLine("-" & objDT.TableName & "-")
            For Each objDC In objDT.Columns
                Console.WriteLine(objDC.ColumnName & _
                                ControlChars.Tab & _
                                objDC.DataType.ToString())
            Next
            Console.WriteLine()
        Next

        objDT = objDS.Tables("Product")
        objIT = objDS.Tables("Inventory")

        objDS.EnforceConstraints = True
        AddNewProduct(objDT, "82312A", "BATTERY-4PKG AA")
        AddNewProduct(objDT, "4088", "TOMATOES-ROMA")
        AddNewInventory(objIT, _
                        "4088", _
                        100, _
                        "123-45", _
                        DateAdd(DateInterval.Day, 10, Now()))

        ListTableContents(objDT)
        ListTableContents(objIT)

    End Sub

    Public Sub AddNewInventory(ByVal pInventoryTable As DataTable, _
                            ByVal pProductSKU As String, _
                            ByVal pQuantity As Integer, _
                            ByVal pBinNumber As String, _
                            ByVal pExpire As Date)

        Try
            Dim dr As DataRow

            dr = pInventoryTable.NewRow()
            dr.Item("InventorySKU") = pProductSKU
            dr.Item("InventoryQuantity") = pQuantity
            dr.Item("InventoryBinNumber") = pBinNumber
            dr.Item("InventoryExpirationDate") = pExpire
            pInventoryTable.Rows.Add(dr)

        Catch E As Exception
            Console.WriteLine("ERROR: " & E.Message)
        End Try

    End Sub

    Public Sub AddNewProduct(ByVal pProductTable As DataTable, _
                                ByVal pProductSKU As String, _
                                ByVal pProductDescription As String)

        Try
            Dim dr As DataRow

            dr = pProductTable.NewRow()
            dr.Item("ProductSKU") = pProductSKU
            dr.Item("ProductDescription") = pProductDescription
            pProductTable.Rows.Add(dr)

        Catch E As Exception
            Console.WriteLine("ERROR: " & E.Message)
        End Try

    End Sub

    Public Sub ListTableContents(ByVal pTable As DataTable)

        Try
            Dim dc As DataColumn
            Dim dr As DataRow
            Dim obj As Object

            For Each dc In pTable.Columns
                Console.Write(dc.ColumnName & _
                                ControlChars.Tab)
            Next
            Console.WriteLine()

            For Each dr In pTable.Rows
                For Each obj In dr.ItemArray
                    Console.Write(obj.ToString() & ControlChars.Tab)
                Next
                Console.WriteLine()
            Next

        Catch E As Exception
            Console.WriteLine("ERROR: " & E.Message)
        End Try

    End Sub

End Module
