Imports System
Imports System.IO
Imports System.Security
Imports System.Security.Cryptography
Imports System.Text

Module Module1

	Private m_bytKey as Byte()
	Private m_bytIV as Byte()

	Sub Main()
        	EncryptFile("test.txt", _
                        "Encrypted.txt" )
                       
        	DecryptFile("Encrypted.txt", _
                    "Decrypted.txt")
	
	End Sub

	Private Sub ReadKeyFile() 
		Dim fsInput As New FileStream("keyfile.key", _
                                    FileMode.Open, FileAccess.Read)
        	Dim bytearrayinput(fsInput.Length - 1) As Byte
        	fsInput.Read(bytearrayinput, 0, bytearrayinput.Length)

		m_bytKey = bytearrayinput

	End Sub

	Private Sub ReadIVFile() 
		Dim fsInput As New FileStream("ivfile.iv", _
                                    FileMode.Open, FileAccess.Read)
        	Dim bytearrayinput(fsInput.Length - 1) As Byte
        	fsInput.Read(bytearrayinput, 0, bytearrayinput.Length)

		m_bytIV = bytearrayinput

	End Sub

	Private Sub SaveKeyFile()
        	Dim fsKeyFile As New FileStream("keyfile.key", _
                                    FileMode.Create, FileAccess.Write)
		fsKeyFile.Write( m_bytKey, 0, m_bytKey.Length )
		fsKeyFile.Flush()
		fsKeyFile.Close()

	End Sub

	Private Sub SaveIVFile()
        	Dim fsKeyFile As New FileStream("ivfile.iv", _
                                    FileMode.Create, FileAccess.Write)
		fsKeyFile.Write( m_bytIV, 0, m_bytIV.Length )
		fsKeyFile.Flush()
		fsKeyFile.Close()

	End Sub

	Public Sub EncryptFile( ByVal pstrInFile As String, _
		ByVal pstrOutFile As String)
        	
		Dim fsInput As New FileStream(pstrInFile, _
                                    FileMode.Open, FileAccess.Read)
        	Dim fsEncrypted As New FileStream(pstrOutFile, _
                                    FileMode.Create, FileAccess.Write)

		Try

	        	Dim RC2Prov As New RC2CryptoServiceProvider()
			RC2Prov.EffectiveKeySize = 128
			RC2Prov.GenerateKey()
			RC2Prov.GenerateIV()

			Dim RC2Encrypt As ICryptoTransform = _
				RC2Prov.CreateEncryptor()

        		Dim cryptostream As New CryptoStream(fsEncrypted, _
                                RC2Encrypt, _
                                CryptoStreamMode.Write)


        		Dim bytearrayinput(fsInput.Length - 1) As Byte
        		fsInput.Read(bytearrayinput, 0, bytearrayinput.Length)

        		cryptostream.Write(bytearrayinput, 0, _
				bytearrayinput.Length)
        		cryptostream.Close()

			m_bytKey = RC2Prov.Key
			m_bytIV = RC2Prov.IV
			SaveKeyFile()
			SaveIVFile()

		Catch E as CryptographicException
		
		End Try
	End Sub

	Public Sub DecryptFile( ByVal pstrInFile As String, _
		ByVal pstrOutFile As String)
	        


		Dim RC2Prov As New RC2CryptoServiceProvider()
		ReadKeyFile()
		ReadIVFile()
		RC2Prov.EffectiveKeySize = 128
        	RC2Prov.Key() = m_bytKey
        	RC2Prov.IV = m_bytIV

        	Dim fsread As New FileStream(pstrInFile, _
			FileMode.Open, _
			FileAccess.Read)
        	Dim RC2Decrypt As ICryptoTransform = _
			RC2Prov.CreateDecryptor()

        	Dim cryptostreamDecr As New CryptoStream(fsread, _
			RC2Decrypt, CryptoStreamMode.Read)
        	
       		Dim fsDecrypted As New StreamWriter(pstrOutFile)
        	fsDecrypted.Write( _
			New StreamReader(cryptostreamDecr).ReadToEnd)
        	fsDecrypted.Flush()
        	fsDecrypted.Close()

	End Sub

End Module
