Imports System
Imports System.Reflection
Imports System.EnterpriseServices
Imports System.Data
Imports System.Data.SqlClient


<Assembly: ApplicationName("Supermarket")> 				
<Assembly: ApplicationActivation(ActivationOption.Library)> 	
<Assembly: AssemblyKeyFile("KeyFile.snk")>				

Namespace Supermarket						

    Public Interface IProduct					
        Function Create(ByVal SKU As String, _
                        ByVal Description As String, _
                        ByVal UnitPrice As Decimal, _
                        ByVal StockingBinNumber As String) _
                        As Boolean
    End Interface

    <ConstructionEnabled([Default]:="Default Construction String"), _	
    Transaction(TransactionOption.Required)> _
    Public Class Product
        Inherits ServicedComponent					
        Implements Supermarket.IProduct				

        Public Sub New()

        End Sub

        Protected Overrides Sub Construct(ByVal constructString As String)	

        End Sub 'Construct

        Function Create(ByVal SKU As String, _
                        ByVal Description As String, _
                        ByVal UnitPrice As Decimal, _
                        ByVal StockingBinNumber As String) _
                        As Boolean _
                        Implements Supermarket.IProduct.Create

            Dim objCnn As SqlConnection
            Dim objCmd As SqlCommand
            Dim objParam As SqlParameter
            Dim intRowsReturned As Integer


            Try
                objCnn = New SqlConnection()
                objCnn.ConnectionString = _
                    "Initial Catalog=Supermarket;Data Source=localhost;uid=sa;pwd="
                objCnn.Open()
                objCmd = objCnn.CreateCommand()
                objCmd.CommandText = _
                    "INSERT INTO Product " & _
                    "( SKU, Description, UnitPrice, StockingBinNumber ) " & _
                    "VALUES ( @sku, @description, @unitprice, @stockingbinnumber )"

                objParam = New SqlParameter()
                With objParam
                    .ParameterName = "@sku"
                    .SqlDbType = SqlDbType.VarChar
                    .Direction = ParameterDirection.Input
                    .Value = SKU
                End With
                objCmd.Parameters.Add(objParam)


                objParam = New SqlParameter()
                With objParam
                    .ParameterName = "@description"
                    .SqlDbType = SqlDbType.VarChar
                    .Direction = ParameterDirection.Input
                    .Value = Description
                End With

                objCmd.Parameters.Add(objParam)
                objParam = New SqlParameter()
                With objParam
                    .ParameterName = "@unitprice"
                    .SqlDbType = SqlDbType.Decimal
                    .Direction = ParameterDirection.Input
                    .Value = UnitPrice
                End With
                objCmd.Parameters.Add(objParam)

                objParam = New SqlParameter()
                With objParam
                    .ParameterName = "@stockingbinnumber"
                    .SqlDbType = SqlDbType.VarChar
                    .Direction = ParameterDirection.Input
                    .Value = StockingBinNumber
                End With
                objCmd.Parameters.Add(objParam)

                intRowsReturned = objCmd.ExecuteNonQuery()
                Create = True
                ContextUtil.SetComplete()				


            Catch E As Exception
                Create = False
                ContextUtil.SetAbort()			
            Finally
                objCnn.Close()
            End Try

        End Function

    End Class

End Namespace
