Imports System
Imports System.IO

Module Module1

    Sub Main()

        Dim objWatcher As New FileSystemWatcher(".\")	

        objWatcher.NotifyFilter = NotifyFilters.FileName Or _	
                        NotifyFilters.Attributes Or _
                        NotifyFilters.LastAccess Or _
                        NotifyFilters.LastWrite Or _
                        NotifyFilters.Security Or _
                        NotifyFilters.Size

        AddHandler objWatcher.Changed, AddressOf OnChanged		
        AddHandler objWatcher.Created, AddressOf OnChanged		
        AddHandler objWatcher.Deleted, AddressOf OnChanged		
        AddHandler objWatcher.Renamed, AddressOf OnRenamed		

        objWatcher.EnableRaisingEvents = True			

        Console.WriteLine("Press Enter to quit")
        Console.WriteLine()
        Console.ReadLine()
    End Sub

    Public Sub OnChanged(ByVal source As Object, _
                        ByVal e As FileSystemEventArgs)
        Dim strChange As String
        Select Case e.ChangeType					
            Case WatcherChangeTypes.Changed
                strChange = "Changed"
            Case WatcherChangeTypes.Created
                strChange = "Created"
            Case WatcherChangeTypes.Deleted
                strChange = "Deleted"
        End Select

        Console.WriteLine("File: {0} {1}", _			
                        e.FullPath, strChange)
    End Sub

    Public Sub OnRenamed(ByVal source As Object, _			
                        ByVal e As RenamedEventArgs)
        Console.WriteLine("File: {0} Renamed to {1}", _		
                        e.OldFullPath, e.FullPath)
    End Sub

End Module
